#include <misc.h> // stdio, time
#import "Output.h"

@implementation Output

-setModel: (id) w {
 	myModelSwarm = w;
return self;
}

- prepareFirmOutputFile
{
  char outputFile[256];

  int i;
  
  if(!runTime)
    runTime = time(NULL);
          
  strcpy (outputFile,"firmStructures.data");
  strcat (outputFile," ");
    
  strcat (outputFile,ctime (&runTime));
  for (i = 0; i < 256; i++)
    {
      if (outputFile[i] == ' ')
	outputFile[i] = '_';
      if (outputFile[i] == '\n')
	outputFile[i] = '\0';
    }
      
  firmDataOutputFile = fopen(outputFile,"w");
  fprintf (firmDataOutputFile,"seed = %d e days = %d \n",[myModelSwarm getSeed], [myModelSwarm getDays]);

//  fprintf (firmDataOutputFile, "current Time\t Struct2\t Struc3\t Struct4\t Struct5\t Strct6\t \n\n");
  return self;
}


- prepareHCOutputFile
{
  char outputFile[256];

  int i;
  
  if(!runTime)
    runTime = time(NULL);
          
  strcpy (outputFile,"HCStructures.data");
  strcat (outputFile," ");
    
  strcat (outputFile,ctime (&runTime));
  for (i = 0; i < 256; i++)
    {
      if (outputFile[i] == ' ')
	outputFile[i] = '_';
      if (outputFile[i] == '\n')
	outputFile[i] = '\0';
    }
      
  HCDataOutputFile = fopen(outputFile,"w");
  fprintf (HCDataOutputFile,"seed = %d e days = %d \n",[myModelSwarm
getSeed], [myModelSwarm getDays]);

//fprintf (HCDataOutputFile,"seed = %d \n",[myModelSwarm getSeed]);

//  fprintf (HCDataOutputFile, "current Time\t HC1\t HC2\t HC3\tHC4\t HC5\t HC6\t \n\n");
  return self;
}


-writeDatas
{
 fprintf (firmDataOutputFile, "%10ld\t %5d\t %5d\t %5d\t %5d\t %5d\t \n",
getCurrentTime (),[myModelSwarm getFirmData:0],[myModelSwarm 
getFirmData:1],[myModelSwarm getFirmData:2],[myModelSwarm getFirmData:3],[myModelSwarm getFirmData:4]);

 fprintf (HCDataOutputFile, "%10ld\t %5d\t %5d\t %5d\t %5d\t %5d\t %5d\n",getCurrentTime (),[myModelSwarm getHCData:0],[myModelSwarm getHCData:1],[myModelSwarm getHCData:2],[myModelSwarm getHCData:3],[myModelSwarm getHCData:4], [myModelSwarm getHCData:5])
;

  return self;
}

-endSimulation {
fclose (firmDataOutputFile);
fclose (HCDataOutputFile);
return self;
} 
@end
